#include "m_malloc.h"
#include "m_utils.h"
#include "m_BranchBound.cpp"
#include "m_TreeNode1b.h"



void
TreeNode1b::cmpBnds(){
   Window smallestWin = winPair.getSmallestWin();
   double *hist1_min = smallestWin.getPosNegScore(integralIms);
   Window largestWin = winPair.getLargestWin();
   double *hist1_max = largestWin.getPosNegScore(integralIms);

   lb = hist1_min[0] - hist1_max[1];
   ub = hist1_max[0] - hist1_max[1];

   destroyVector<double>(hist1_min, 2);
   destroyVector<double>(hist1_max, 2);
}

double ***TreeNode1b::integralIms = NULL;

TreeNode1b findBox1b_helper(double ***integralIms, int imW, int imH)
{
    TreeNode1b::integralIms = integralIms;
    Window biggestWin(0, 0, imW - 1, imH - 1);
    TreeNode1b rootNode(WindowPair(biggestWin, biggestWin));
    double tolFactor = 0;
    TreeNode1b bestNode = m_branch_bound<TreeNode1b>(rootNode, tolFactor);
    return bestNode;
}


Window findBox1b(int **kpAssign, int nKeyPnt, int imH, int imW,
                 double *weights, int nHistBin){
   double ***integralIms = cmpIntegralIms3(kpAssign, nKeyPnt, imH, imW, weights, nHistBin);
   TreeNode1b bestNode = findBox1b_helper(integralIms, imW, imH);
   destroyArrayThree<double>(integralIms, imH, imW, 2);
   return bestNode.winPair.getLargestWin();
}

Window findBox1b2(double **pixVals, int imH, int imW){
   double ***integralIms = cmpIntegralIms4(pixVals, imH, imW);
   TreeNode1b bestNode = findBox1b_helper(integralIms, imW, imH);
   destroyArrayThree<double>(integralIms, imH, imW, 2);
   return bestNode.winPair.getLargestWin();
}
