#include <iostream>
#include <cmath>
#include <queue>
#include <string>
#include <sstream>
#include <fstream>
#include "m_utils.h"
#include "m_malloc.h"
#include "m_TreeNode1f.h"
#include "m_BranchBound.cpp"
#include "m_tests.h"

void test1f_1(){
   int imH1 = 3;
   int imW1 = 4;
   
   int nHistBin = 2;
   int nTest = 11;

   double returnE;

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double **weights = buildMatrix<double>(1,2);

   weights[0][0] = 10; 
   weights[0][1] = -1;
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   
   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,2);
   szRanges[i] = SizeRange(0, 3, 0, 4);

   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);

   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,1,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);


   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(0, 2, 0, 2);

   i = 4;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 3);

   i = 5;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,3,2);
   szRanges[i] = SizeRange(2, 2, 2, 3);

   i = 6;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(0, 2, 2, 3);

   i = 7;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(2, 2, 2, 2);

   i = 8;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(2, 2, 1, 1);

   i = 9;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,0,2,0);
   szRanges[i] = SizeRange(1, 1, 2, 2);

   i = 10;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,2, 3,2);
   szRanges[i] = SizeRange(1, 1, 2, 3);


   int **im1 = buildMatrix<int>(imH1, imW1);
            
   for (int k= 0; k < nTest; k++){
      cout << "==============Testing test1f_1." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }      
         cout << endl;
      }
      

      int ***integralIms1 = cmpIntegralIms(im1, imH1, imW1, nHistBin);
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1);       
      Window bestBBox = findBox1f(kpAssign1, imH1*imW1, imH1, imW1, weights, nHistBin, 4, 0, szRanges[k], 0, &returnE);
      destroyMatrix<int>(kpAssign1, imH1*imW1,3);
      double energy_best = returnE;
      

      cout << "Best window " << bestBBox.str()  
         << ", energy: " << energy_best << ", returned E: " << returnE << endl;      

      int *hist1_exp = expBBoxes[k].getHist(integralIms1, nHistBin);
      double energy_exp = cmpEnergy2(hist1_exp, weights[0], nHistBin);

      if (energy_best < energy_exp){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best > energy_exp){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << endl;
      } else {
         cout << "PASSED" << endl;
      }
      destroyArrayThree<int>(integralIms1, imH1, imW1, nHistBin);      
      destroyVector<int>(hist1_exp, nHistBin);
      cout << endl; 
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   destroyMatrix<double>(weights, 1, 2);
   
   delete [] expBBoxes;
   delete [] szRanges;
}


void test1f_2(){
   //return;
   int imH1 = 3;
   int imW1 = 4;
   
   int nLevel = 1;
   int nBranch = 4;

   int nHistBin = 2;
   int nTest = 11;

   double energy_best;

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   vector<double **> weightsss;
   double **weightss;

   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   
   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,2);
   szRanges[i] = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 10; 
   weightss[0][1] = -1;
   weightss[1][0] = 10; 
   weightss[1][1] = -1;
   weightss[2][0] = 10; 
   weightss[2][1] = -1;
   weightss[3][0] = 10; 
   weightss[3][1] = -1;
   weightss[4][0] = 10; 
   weightss[4][1] = -1;

   weightsss.push_back(weightss);
   
   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,3,2);
   szRanges[i] = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 10; 
   weightss[0][1] = -10;
   weightss[1][0] = 10; 
   weightss[1][1] = -1;
   weightss[2][0] = 10; 
   weightss[2][1] = -1;
   
   weightss[3][0] = -1; 
   weightss[3][1] = 10;

   weightss[4][0] = -1; 
   weightss[4][1] = 10;
   weightsss.push_back(weightss);


   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,3,2);
   szRanges[i] = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 1; 
   weightss[0][1] = -1;
   
   weightss[1][0] = -1; 
   weightss[1][1] = 1;

   weightss[2][0] = 1; 
   weightss[2][1] = -1;
   
   weightss[3][0] = -1; 
   weightss[3][1] = 1;

   weightss[4][0] = -1; 
   weightss[4][1] = 1;
   weightsss.push_back(weightss);


   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(2,0,3,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 1; 
   weightss[0][1] = -1;
   
   weightss[1][0] = -1; 
   weightss[1][1] = 1;

   weightss[2][0] = 1; 
   weightss[2][1] = -1;
   
   weightss[3][0] = -1; 
   weightss[3][1] = 1;

   weightss[4][0] = -1; 
   weightss[4][1] = 1;
   weightsss.push_back(weightss);

   i = 4; 
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,0,1,1);
   szRanges[i]  = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 0; 
   weightss[0][1] = 0;
   
   weightss[1][0] = -1; 
   weightss[1][1] = 1;

   weightss[2][0] = 1; 
   weightss[2][1] = -1;
   
   weightss[3][0] = 1; 
   weightss[3][1] = -1;

   weightss[4][0] = -1; 
   weightss[4][1] = 1;
   weightsss.push_back(weightss);

   i = 5;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i]  = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 0; 
   weightss[0][1] = 0;
   
   weightss[1][0] = 1; 
   weightss[1][1] = -1;

   weightss[2][0] = -1; 
   weightss[2][1] = 1;
   
   weightss[3][0] = -1; 
   weightss[3][1] = 1;

   weightss[4][0] = 1; 
   weightss[4][1] = -1;
   weightsss.push_back(weightss);

   i = 6;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(2,0,3,1);
   szRanges[i]  = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 0; 
   weightss[0][1] = 0;
   
   weightss[1][0] = -1; 
   weightss[1][1] = 1;

   weightss[2][0] = 1; 
   weightss[2][1] = -1;
   
   weightss[3][0] = -1; 
   weightss[3][1] = 1;

   weightss[4][0] = 1; 
   weightss[4][1] = -1;
   weightsss.push_back(weightss);

   i = 7;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,1,2);
   szRanges[i]  = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 0; 
   weightss[0][1] = 0;
   
   weightss[1][0] = 1; 
   weightss[1][1] = -1;

   weightss[2][0] = 1; 
   weightss[2][1] = -1;
   
   weightss[3][0] = -1; 
   weightss[3][1] = 1;

   weightss[4][0] = -1; 
   weightss[4][1] = 1;
   weightsss.push_back(weightss);

   i = 8;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,2,2);
   szRanges[i]  = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 0; 
   weightss[0][1] = 0;
   
   weightss[1][0] = -1; 
   weightss[1][1] = 1;

   weightss[2][0] = -1; 
   weightss[2][1] = 1;
   
   weightss[3][0] = 1; 
   weightss[3][1] = -1;

   weightss[4][0] = -1; 
   weightss[4][1] = 1;
   weightsss.push_back(weightss);

   i = 9;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(2,1,3,2);
   szRanges[i]  = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = 0; 
   weightss[0][1] = 0;
   
   weightss[1][0] = 1; 
   weightss[1][1] = -1;

   weightss[2][0] = -1; 
   weightss[2][1] = 1;
   
   weightss[3][0] = 1; 
   weightss[3][1] = -1;

   weightss[4][0] = 1; 
   weightss[4][1] = -1;
   weightsss.push_back(weightss);

   i = 10;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 1; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0, 0, 3,2);
   szRanges[i]  = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(5,2);
   weightss[0][0] = -1; 
   weightss[0][1] = -1;
   
   weightss[1][0] = -1; 
   weightss[1][1] = -1;

   weightss[2][0] = -1; 
   weightss[2][1] = -1;
   
   weightss[3][0] = -1; 
   weightss[3][1] = -1;

   weightss[4][0] = -1; 
   weightss[4][1] = -1;
   weightsss.push_back(weightss);

   int **im1 = buildMatrix<int>(imH1, imW1);            
   for (int k= 0; k < nTest; k++){
   //for (int k= 4; k < 5; k++){
      cout << "==============Testing test1f_2." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }      
         cout << endl;
      }
      



      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1); 
      Window bestBBox = findBox1f(kpAssign1, imH1*imW1, imH1, imW1, weightsss[k], nHistBin, nBranch, nLevel, szRanges[k], 0, &energy_best);
      cout << "Best window " << bestBBox.str() << ", energy: " << energy_best << endl;      
      

      IntImTree intImTree(kpAssign1, imH1*imW1, imH1, imW1, weightsss[k], nHistBin, nBranch, nLevel);    
      double energy_exp = intImTree.cmpE(expBBoxes[k]); 

      if (energy_best < energy_exp){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best > energy_exp){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << endl;
      } else {
         cout << "PASSED" << endl;
      }
        
      cout << endl; 
      destroyMatrix<int>(kpAssign1, imH1*imW1,3);
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   for (int k= 0; k < nTest; k++){
      destroyMatrix<double>(weightsss[k], 5, 2);
   }
   
   delete [] expBBoxes;
   delete [] szRanges;
}


void test1f_3(){
   //return;
   int imH1 = 3;
   int imW1 = 4;
   
   int nLevel = 0;
   int nBranch = 4;

   int nHistBin = 2;
   int nTest = 1;

   double energy_best;

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   vector<double **> weightsss;
   double **weightss;

   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   
   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(0, 0, 3, 2);
   szRanges[i] = SizeRange(0, 3, 0, 4);

   weightss = buildMatrix<double>(1,2);
   weightss[0][0] = -1;
   weightss[0][1] = -1;


   weightsss.push_back(weightss);
   
   

   int **im1 = buildMatrix<int>(imH1, imW1);            
   for (int k= 0; k < nTest; k++){
   //for (int k= 4; k < 5; k++){
      cout << "==============Testing test1f_3." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }      
         cout << endl;
      }
      

      weightss = weightsss[k];
      

      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1); 
      Window bestBBox = findBox1f(kpAssign1, imH1*imW1, imH1, imW1, weightss, nHistBin, nBranch, nLevel, szRanges[k], 0, &energy_best);
      cout << "Best window " << bestBBox.str() << ", energy: " << energy_best << endl;      
      

      IntImTree intImTree(kpAssign1, imH1*imW1, imH1, imW1, weightsss[k], nHistBin, nBranch, nLevel); 
      double energy_exp = intImTree.cmpE(expBBoxes[k]); 

      if (energy_best < energy_exp){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best > energy_exp){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << endl;
      } else {
         cout << "PASSED" << endl;
      }
        
      cout << endl; 
      destroyMatrix<int>(kpAssign1, imH1*imW1,3);
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   for (int k= 0; k < nTest; k++){
      destroyMatrix<double>(weightsss[k], 1, 2);
   }
   
   delete [] expBBoxes;
   delete [] szRanges;
}

void test1f_4(){
   int imH1 = 3;
   int imW1 = 4;
   
   int nHistBin = 2;
   int nTest = 1;

   double returnE;

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double **weights = buildMatrix<double>(1,2);

   weights[0][0] = -0.1; 
   weights[0][1] = -0.1;
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   
   int i = 0;
   imAssign1[0][0][i] = 2; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 2;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 2; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,0,3,2);
   szRanges[i] = SizeRange(0, 3, 0, 4);

   

   int **im1 = buildMatrix<int>(imH1, imW1);
            
   for (int k= 0; k < nTest; k++){
      cout << "==============Testing test1f_4." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }      
         cout << endl;
      }
      

      int ***integralIms1 = cmpIntegralIms(im1, imH1, imW1, nHistBin);
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1); 
      Window bestBBox = findBox1f(kpAssign1, imH1*imW1, imH1, imW1, weights, nHistBin, 4, 0, szRanges[k], 0, &returnE);

      double energy_best = returnE;
      

      cout << "Best window " << bestBBox.str()  
         << ", energy: " << energy_best << ", returned E: " << returnE << endl;      

      int *hist1_exp = expBBoxes[k].getHist(integralIms1, nHistBin);
      double energy_exp = cmpEnergy2(hist1_exp, weights[0], nHistBin);

      if (energy_best < energy_exp - EPS){
         cout << "WARNING: expected energy is bigger than returned energy" << endl;
      } else if (energy_best - EPS> energy_exp){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << endl;
      } else {
         cout << "PASSED" << endl;
      }
      destroyArrayThree<int>(integralIms1, imH1, imW1, nHistBin);   
      
      destroyMatrix<int>(kpAssign1, imH1*imW1, 3);      
      destroyVector<int>(hist1_exp, nHistBin);
      cout << endl; 
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   destroyMatrix<double>(weights, 1, 2);
   
   delete [] expBBoxes;
   delete [] szRanges;
}