#include <iostream>
#include <cmath>
#include <queue>
#include <string>
#include <sstream>
#include <fstream>
#include "m_utils.h"
#include "m_malloc.h"
#include "m_TreeNode1g.h"
#include "m_BranchBound.cpp"
#include "m_tests.h"

void test1g_1(){
   int imH1 = 3;
   int imW1 = 4;
   
   int nHistBin = 2;
   int nTest = 22;

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double **weights = buildMatrix<double>(nTest, 2); 
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   Window *gtWins = new Window[nTest];
   
   int i = 0;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 2;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,2);
   szRanges[i] = SizeRange(0, 3, 0, 4);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 1;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 2;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,1,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;


   i = 3;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 4;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 3);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 5;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,3,2);
   szRanges[i] = SizeRange(2, 2, 2, 3);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 6;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,2,1);
   szRanges[i] = SizeRange(0, 2, 2, 3);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 7;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,0,2,1);
   szRanges[i] = SizeRange(2, 2, 2, 2);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 8;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(2, 2, 1, 1);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 9;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,0,2,0);
   szRanges[i] = SizeRange(1, 1, 2, 2);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 10;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,2, 3,2);
   szRanges[i] = SizeRange(1, 1, 2, 3);
   gtWins[i] = Window(-1,-1,-1,-1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 11;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(2,0,2,1);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   gtWins[i] = Window(0,0,1,1);
   weights[i][0] = 1; weights[i][1] = -0.1;
   //gtWins[i] = Window(-1,-1,-1,-1);
   

   i = 12;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(2,0,2,0);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   gtWins[i] = Window(0,1,2,2);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 13;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(0, 2, 0, 2);
   gtWins[i] = Window(0,1,2,2);
   weights[i][0] = 10; weights[i][1] = -1;

   i = 14;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(2,1,3,1);
   szRanges[i] = SizeRange(0, 2, 0, 3);
   gtWins[i] = Window(1,1,1,1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 15;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,3,1);
   szRanges[i] = SizeRange(0, 2, 0, 3);
   gtWins[i] = Window(1,1,1,1);
   weights[i][0] = 10; weights[i][1] = -1;

   i = 16;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 2; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 2; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 2; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(0,1,3,1);
   szRanges[i] = SizeRange(0, 2, 0, 4);
   gtWins[i] = Window(1,1,1,1);
   weights[i][0] = 10; weights[i][1] = -1;

   i = 17;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(2,0,3,1);
   szRanges[i] = SizeRange(2, 2, 2, 2);
   gtWins[i] = Window(1,1,1,1);
   weights[i][0] = 0.1; weights[i][1] = -0.01;

   i = 18;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,2,2);
   szRanges[i] = SizeRange(2, 2, 2, 2);
   gtWins[i] = Window(1,1,1,1);
   weights[i][0] = 10; weights[i][1] = -1;

   i = 19;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(1,1,1,2);
   szRanges[i] = SizeRange(2, 2, 1, 2);
   gtWins[i] = Window(1,1,1,1);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 20;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 2;
   imAssign1[0][2][i] = 2; imAssign1[1][2][i] = 1; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 2;

   expBBoxes[i] = Window(-1,-1,-1,-1);
   szRanges[i] = SizeRange(0, 1, 0, 3);
   gtWins[i] = Window(1,0,3,2);
   weights[i][0] = 1; weights[i][1] = -0.1;

   i = 21;
   imAssign1[0][0][i] = 1; imAssign1[1][0][i] = 1; imAssign1[2][0][i] = 1;
   imAssign1[0][1][i] = 1; imAssign1[1][1][i] = 2; imAssign1[2][1][i] = 1;
   imAssign1[0][2][i] = 1; imAssign1[1][2][i] = 2; imAssign1[2][2][i] = 1;
   imAssign1[0][3][i] = 1; imAssign1[1][3][i] = 1; imAssign1[2][3][i] = 1;

   expBBoxes[i] = Window(1,1,1,1);
   szRanges[i] = SizeRange(1, 1, 1, 1);
   gtWins[i] = Window(0,0,3,2);
   weights[i][0] = 1; weights[i][1] = -1;

   int **im1 = buildMatrix<int>(imH1, imW1);

   
            
   for (int k= 0; k < nTest; k++){
   //for (int k= 4; k < 5; k++){
      cout << "==============Testing test1g_1." << k << endl;
      cout << "image 1: " << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];
            printf("%2d ", im1[i][j]);
         }      
         cout << endl;
      }      

      int ***integralIms1 = cmpIntegralIms(im1, imH1, imW1, nHistBin);
      
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1);
      Window bestBBox = findBox1g(kpAssign1, imH1*imW1, imH1, imW1, weights[k], nHistBin, gtWins[k], szRanges[k]);
      
      int *hist1_best = bestBBox.getHist(integralIms1, nHistBin);
      double energy_best = cmpEnergy2(hist1_best, weights[k], nHistBin);
      
      Window inter1 = bestBBox.intersectWin(gtWins[k]);
      double minArea = (double)inter1.getArea();
      Window union1 = bestBBox.unionWin(gtWins[k]);
      double maxArea = (double)union1.getArea();

      if (maxArea > 0) energy_best += minArea/maxArea;

      cout << "gtWin " << gtWins[k].str() << endl;
      cout << "size range " << szRanges[k].str() << endl;

      cout << "Best window " << bestBBox.str()  
           << ", energy: " << energy_best << endl;      

      int *hist1_exp = expBBoxes[k].getHist(integralIms1, nHistBin);
      double energy_exp = cmpEnergy2(hist1_exp, weights[k], nHistBin);

      inter1 = expBBoxes[k].intersectWin(gtWins[k]);
      minArea = (double)inter1.getArea();
      union1 = expBBoxes[k].unionWin(gtWins[k]);
      maxArea = (double)union1.getArea();
      if (maxArea > 0) energy_exp += minArea/maxArea;

      if (energy_best < energy_exp){
         cout << "WARNING: expected energy " << energy_exp << " is bigger than returned energy " << energy_best << endl;
      } else if (energy_best > energy_exp){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << "<=============FAILED" << endl;
      } else {
         cout << "PASSED" << endl;
      }
      destroyArrayThree<int>(integralIms1, imH1, imW1, nHistBin);
      destroyVector<int>(hist1_best, nHistBin);
      destroyVector<int>(hist1_exp, nHistBin);
      destroyMatrix<int>(kpAssign1, imH1*imW1, 3);
      cout << endl; 
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   delete [] expBBoxes;
   delete [] szRanges;
   delete [] gtWins;
   destroyMatrix<double>(weights, nTest, 2);
}


void test1g_2(){
   int imH1 = 100;
   int imW1 = 200;
   
   int nHistBin = 2;
   int nTest = 1;

   int ***imAssign1 = buildArrayThree<int>(imH1, imW1, nTest);
   double **weights = buildMatrix<double>(nTest, 2); 
   Window *expBBoxes = new Window[nTest];
   SizeRange *szRanges = new SizeRange[nTest];
   Window *gtWins = new Window[nTest];
   
   int i = 0;
   for (int j=0; j < imH1; j++){
      for (int k=0; k < imW1; k++){
         imAssign1[j][k][i] = 1;
      }
   }
   for (int j=49; j < 69 ; j++){
      for (int k=79; k < 119; k++){
         imAssign1[j][k][i] = 2;
      }
   }

   expBBoxes[i] = Window(1,1,20,20);
   szRanges[i] = SizeRange(20, 20, 20, 20);
   gtWins[i] = Window(79, 49, 199, 99);
   weights[i][0] = 0.0000001; weights[i][1] = -0.0000091;

   int **im1 = buildMatrix<int>(imH1, imW1);

            
   for (int k= 0; k < nTest; k++){
   //for (int k= 4; k < 5; k++){
      cout << "==============Testing test1g_2." << k << endl;
      for (int i = 0; i< imH1; i++){
         for (int j= 0; j < imW1; j++){
            im1[i][j] = imAssign1[i][j][k];            
         }      
      }    
      int ***integralIms1 = cmpIntegralIms(im1, imH1, imW1, nHistBin);
      
      int** kpAssign1 = imAssign2kpAssign(im1, imH1, imW1);
      Window bestBBox = findBox1g(kpAssign1, imH1*imW1, imH1, imW1, weights[k], nHistBin, gtWins[k], szRanges[k]);

      
      int *hist1_best = bestBBox.getHist(integralIms1, nHistBin);
      double energy_best = cmpEnergy2(hist1_best, weights[k], nHistBin);
      
      Window inter1 = bestBBox.intersectWin(gtWins[k]);
      double minArea = (double)inter1.getArea();
      Window union1 = bestBBox.unionWin(gtWins[k]);
      double maxArea = (double)union1.getArea();

      if (maxArea > 0) energy_best += minArea/maxArea;

      cout << "gtWin " << gtWins[k].str() << endl;
      cout << "size range " << szRanges[k].str() << endl;

      cout << "Best window " << bestBBox.str()  
           << ", energy: " << energy_best << endl;      

      int *hist1_exp = expBBoxes[k].getHist(integralIms1, nHistBin);
      double energy_exp = cmpEnergy2(hist1_exp, weights[k], nHistBin);

      inter1 = expBBoxes[k].intersectWin(gtWins[k]);
      minArea = (double)inter1.getArea();
      union1 = expBBoxes[k].unionWin(gtWins[k]);
      maxArea = (double)union1.getArea();
      if (maxArea > 0) energy_exp += minArea/maxArea;

      if (energy_best < energy_exp){
         cout << "WARNING: expected energy " << energy_exp << " is bigger than returned energy " << energy_best << endl;
      } else if (energy_best > energy_exp){
         cout << "FAILED, expected BBoxes: " << expBBoxes[k].str() << "<=============FAILED" << endl;
      } else {
         cout << "PASSED" << endl;
      }
      destroyArrayThree<int>(integralIms1, imH1, imW1, nHistBin);
      destroyVector<int>(hist1_best, nHistBin);
      destroyVector<int>(hist1_exp, nHistBin);
      destroyMatrix<int>(kpAssign1, imH1*imW1, 3);
      cout << endl; 
   }

   destroyArrayThree<int>(imAssign1, imH1, imW1, nTest);
   destroyMatrix<int>(im1, imH1, imW1);
   delete [] expBBoxes;
   delete [] szRanges;
   delete [] gtWins;
   destroyMatrix<double>(weights, nTest, 2);
}
